import { world } from '@minecraft/server';

const AxeOfBerserkerComponent = {
    onHitEntity({ hitEntity }) {
        let chance = 0.10;  // Mặc định là 3% cơ hội
        let effectDuration = 1;  // Mặc định là 1 giây
        let effectAmplifier = 0;  // Cấp độ của hiệu ứng luôn là 1

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("instant_damage", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });

            // Lấy vị trí của thực thể bị đánh trúng
            const position = hitEntity.location;
            const dimension = hitEntity.dimension;

            // Phát âm thanh tại vị trí của thực thể bị đánh trúng
            dimension.runCommandAsync(`playsound hit.bonus @a ${position.x} ${position.y} ${position.z} 4`).then(() => {
                console.log(`Executed hammer_sound at position ${position.x}, ${position.y}, ${position.z}`);
            }).catch(error => {
                console.error(`Failed to execute playsound at position ${position.x}, ${position.y}, ${position.z}:`, error);
            });
        }
    }
};

// Đăng ký custom component fv:battle_axe
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:axe_of_berserker", AxeOfBerserkerComponent);
});