import { world } from "@minecraft/server";

// Custom component để áp dụng sát thương khi tấn công và gọi function hammer_sound
const BigSwordComponent = {
    onHitEntity({ hitEntity, source }) {
        let chance = 0.05;  // 10% cơ hội gây sát thương
        let extraDamage = 20;  // Sát thương thêm

        // Áp dụng sát thương nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.applyDamage(extraDamage);
            console.log(`Đã gây ${extraDamage} sát thương lên thực thể.`);

            // Lấy vị trí của thực thể bị đánh trúng
            const position = hitEntity.location;
            const dimension = hitEntity.dimension;

            // Phát âm thanh tại vị trí của thực thể bị đánh trúng
            dimension.runCommandAsync(`playsound hit.bonus @a ${position.x} ${position.y} ${position.z} 4`).then(() => {
                console.log(`Executed hammer_sound at position ${position.x}, ${position.y}, ${position.z}`);
            }).catch(error => {
                console.error(`Failed to execute playsound at position ${position.x}, ${position.y}, ${position.z}:`, error);
            });
        }
    }
};

// Đăng ký custom component fv:big_sword
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:big_sword", BigSwordComponent);
});

const BigSwordComponentLv2 = {
    onHitEntity({ hitEntity, source }) {
        let chance = 0.05;  // 10% cơ hội gây sát thương
        let extraDamage = 30;  // Sát thương thêm

        // Áp dụng sát thương nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.applyDamage(extraDamage);
            console.log(`Đã gây ${extraDamage} sát thương lên thực thể.`);

            // Lấy vị trí của thực thể bị đánh trúng
            const position = hitEntity.location;
            const dimension = hitEntity.dimension;

            // Phát âm thanh tại vị trí của thực thể bị đánh trúng
            dimension.runCommandAsync(`playsound hit.bonus @a ${position.x} ${position.y} ${position.z} 4`).then(() => {
                console.log(`Executed hammer_sound at position ${position.x}, ${position.y}, ${position.z}`);
            }).catch(error => {
                console.error(`Failed to execute playsound at position ${position.x}, ${position.y}, ${position.z}:`, error);
            });
        }
    }
};

// Đăng ký custom component fv:big_sword
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:big_sword_lv2", BigSwordComponentLv2);
});


const BigSwordComponentLv3 = {
    onHitEntity({ hitEntity, source }) {
        let chance = 0.10;  // 10% cơ hội gây sát thương
        let extraDamage = 40;  // Sát thương thêm

        // Áp dụng sát thương nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.applyDamage(extraDamage);
            console.log(`Đã gây ${extraDamage} sát thương lên thực thể.`);

            // Lấy vị trí của thực thể bị đánh trúng
            const position = hitEntity.location;
            const dimension = hitEntity.dimension;

            // Phát âm thanh tại vị trí của thực thể bị đánh trúng
            dimension.runCommandAsync(`playsound hit.bonus @a ${position.x} ${position.y} ${position.z} 4`).then(() => {
                console.log(`Executed hammer_sound at position ${position.x}, ${position.y}, ${position.z}`);
            }).catch(error => {
                console.error(`Failed to execute playsound at position ${position.x}, ${position.y}, ${position.z}:`, error);
            });
        }
    }
};

// Đăng ký custom component fv:big_sword
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:big_sword_lv3", BigSwordComponentLv3);
});
