import { world, Entity } from '@minecraft/server';

const HeavyAxeComponent = {
    onHitEntity({ hitEntity }) {
        let chance = 0.15;  // Mặc định là 10% cơ hội
        let effectDuration = 5;  // Mặc định là 5 giây
        let effectAmplifier = 1;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("hunger", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:heavy_axe", HeavyAxeComponent);
});

const HeavyAxeComponentLv2 = {
    onHitEntity({ hitEntity }) {
        let chance = 0.20;  // Mặc định là 10% cơ hội
        let effectDuration = 5;  // Mặc định là 5 giây
        let effectAmplifier = 2;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("hunger", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:heavy_axe_lv2", HeavyAxeComponentLv2);
});

const HeavyAxeComponentLv3 = {
    onHitEntity({ hitEntity }) {
        let chance = 0.25;  // Mặc định là 10% cơ hội
        let effectDuration = 5;  // Mặc định là 5 giây
        let effectAmplifier = 3;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("hunger", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:heavy_axe_lv3", HeavyAxeComponentLv3);
});