import { world, Entity } from '@minecraft/server';

const AxeOfBerserkerUseStrengthComponent = {
    onCompleteUse(event) {
        const player = event.source; // Lấy người chơi (source entity)
        const itemStack = event.itemStack; // Lấy item stack hoàn thành việc sử dụng

        if (player instanceof Entity && itemStack) {
            // Áp dụng hiệu ứng strength cấp 0 trong 30 giây
            player.addEffect("strength", 15 * 20, {
                amplifier: 1,  // Cấp độ 0
                showParticles: true
            });

            console.log("Applied speed to player.");
        } else {
            console.warn("Source is not a valid player or itemStack is missing.");
        }
    }
};

// Đăng ký custom component fv:spear_use_lv2
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:axe_of_berserker_use_strength", AxeOfBerserkerUseStrengthComponent);
});

const AxeOfBerserkerUseRegenerationComponent = {
    onCompleteUse(event) {
        const player = event.source; // Lấy người chơi (source entity)
        const itemStack = event.itemStack; // Lấy item stack hoàn thành việc sử dụng

        if (player instanceof Entity && itemStack) {
            // Áp dụng hiệu ứng strength cấp 0 trong 30 giây
            player.addEffect("regeneration", 20 * 20, {
                amplifier: 1,  // Cấp độ 0
                showParticles: true
            });

            console.log("Applied speed to player.");
        } else {
            console.warn("Source is not a valid player or itemStack is missing.");
        }
    }
};

// Đăng ký custom component fv:spear_use_lv2
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:axe_of_berserker_use_regeneration", AxeOfBerserkerUseRegenerationComponent);
});

const AxeOfBerserkerUseMaxComponent = {
    onCompleteUse(event) {
        const player = event.source; // Lấy người chơi (source entity)
        const itemStack = event.itemStack; // Lấy item stack hoàn thành việc sử dụng

        if (player instanceof Entity && itemStack) {
            // Áp dụng hiệu ứng strength cấp 0 trong 30 giây
            player.addEffect("absorption", 20 * 20, {
                amplifier: 0,  // Cấp độ 0
                showParticles: true
            });

            console.log("Applied speed to player.");
        } else {
            console.warn("Source is not a valid player or itemStack is missing.");
        }
    }
};

// Đăng ký custom component fv:spear_use_lv2
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:axe_of_berserker_use_max", AxeOfBerserkerUseMaxComponent);
});

const AxeOfBerserkerUseStrengthMaxComponent = {
    onCompleteUse(event) {
        const player = event.source; // Lấy người chơi (source entity)
        const itemStack = event.itemStack; // Lấy item stack hoàn thành việc sử dụng

        if (player instanceof Entity && itemStack) {
            // Áp dụng hiệu ứng strength cấp 0 trong 30 giây
            player.addEffect("strength", 15 * 20, {
                amplifier: 2,  // Cấp độ 0
                showParticles: true
            });

            console.log("Applied speed to player.");
        } else {
            console.warn("Source is not a valid player or itemStack is missing.");
        }
    }
};

// Đăng ký custom component fv:spear_use_lv2
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:axe_of_berserker_use_strength_max", AxeOfBerserkerUseStrengthMaxComponent);
});