import { world, system } from "@minecraft/server";

//LEAGUE

// Định nghĩa custom component cho thanh kiếm đặc biệt
const SwordThaneGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("special") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("swordman")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_special' cho thực thể
            try {
                targetEntity.triggerEvent("become_stronger");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a special swordman soldier`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:swordthane_gear", SwordThaneGearComponent);
});

// Định nghĩa custom component cho thanh kiếm đặc biệt
const AgileAxeGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'special' và 'axeman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("special") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("axeman")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_stronger' cho thực thể
            try {
                targetEntity.triggerEvent("become_stronger");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a special axe soldier`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:agile_axe_gear", AgileAxeGearComponent);
});

// Định nghĩa custom component cho thanh kiếm đặc biệt
const GeneralGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'special' và 'axeman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("special")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_general' cho thực thể
            try {
                targetEntity.triggerEvent("become_general");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near any special soldier`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:general_medal", GeneralGearComponent);
});

const GuardMedalComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'special' và 'axeman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomeguard")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_guard' cho thực thể
            try {
                targetEntity.triggerEvent("become_guard");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near your soldier who you need to upgrade`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:guard_medal", GuardMedalComponent);
});

// Định nghĩa custom component cho thanh kiếm đặc biệt
const SpecialSwordGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomespecial") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("swordman")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_special' cho thực thể
            try {
                targetEntity.triggerEvent("become_special");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar "You need to stay near a swordman elite or royal soldier"`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:special_sword_gear", SpecialSwordGearComponent);
});

// Định nghĩa custom component cho thanh kiếm đặc biệt
const SpecialCrossbowGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomespecial") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("crossbowman")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_special' cho thực thể
            try {
                targetEntity.triggerEvent("become_special");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar "You need to stay near a crossbowman elite or royal soldier"`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:special_crossbow_gear", SpecialCrossbowGearComponent);
});

// Định nghĩa custom component cho thanh kiếm đặc biệt
const SpecialSpearGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomespecial") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("spearman")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_special' cho thực thể
            try {
                targetEntity.triggerEvent("become_special");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar "You need to stay near a spearman elite or royal soldier"`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:special_spear_gear", SpecialSpearGearComponent);
});

// Định nghĩa custom component cho thanh kiếm đặc biệt
const SpecialAxeGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomespecial") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("axeman")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_special' cho thực thể
            try {
                targetEntity.triggerEvent("become_special");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar "You need to stay near a axeman elite or royal soldier"`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:special_axe_gear", SpecialAxeGearComponent);
});

//BLUE

// Định nghĩa custom component cho thanh kiếm đặc biệt
const BlueChampionGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("blue") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("swordtype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomechampion") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("diamondlv")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_champion' cho thực thể
            try {
                targetEntity.triggerEvent("become_champion");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a blue dimaond swordman full level`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:blue_champion_gear", BlueChampionGearComponent);
});

// Định nghĩa custom component cho thanh kiếm đặc biệt
const BlueIronBowGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("blue") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("bowtype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomeiron")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_iron' cho thực thể
            try {
                targetEntity.triggerEvent("become_iron");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a blue bowman`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:blue_iron_bow_gear", BlueIronBowGearComponent);
});

// Định nghĩa custom component cho thanh kiếm đặc biệt
const BlueIronCrossbowGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("blue") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("crossbowtype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomeiron")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_iron' cho thực thể
            try {
                targetEntity.triggerEvent("become_iron");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a blue crossbowman`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:blue_iron_crossbow_gear", BlueIronCrossbowGearComponent);
});

const BlueIronSpearGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("blue") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("speartype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomeiron")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_iron' cho thực thể
            try {
                targetEntity.triggerEvent("become_iron");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a blue spearman`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:blue_iron_spear_gear", BlueIronSpearGearComponent);
});

const BlueIronSwordGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("blue") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("swordtype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomeiron")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_iron' cho thực thể
            try {
                targetEntity.triggerEvent("become_iron");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a blue swordman`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:blue_iron_sword_gear", BlueIronSwordGearComponent);
});

const BlueDiamondCrossbowGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("blue") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("crossbowtype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomediamond")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_diamond");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a blue crossbowman`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:blue_diamond_crossbow_gear", BlueDiamondCrossbowGearComponent);
});

const BlueDiamondGunGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("blue") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("bowtype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomediamond")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_diamond");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a blue bowman`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:blue_diamond_gun_gear", BlueDiamondGunGearComponent);
});

const BlueDiamondSpearGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("blue") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("speartype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomediamond")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_diamond");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a blue spearman`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:blue_diamond_spear_gear", BlueDiamondSpearGearComponent);
});

const BlueDiamondSwordGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("blue") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("swordtype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomediamond")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_diamond");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a blue swordman`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:blue_diamond_sword_gear", BlueDiamondSwordGearComponent);
});

//RED

// Định nghĩa custom component cho thanh kiếm đặc biệt
const RedChampionGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("red") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("swordtype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomechampion") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("diamondlv")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_champion' cho thực thể
            try {
                targetEntity.triggerEvent("become_champion");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a red diamond swordman full level`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:red_champion_gear", RedChampionGearComponent);
});

const RedIronSwordGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("red") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("swordtype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomeiron")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_iron");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a red swordman`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:red_iron_sword_gear", RedIronSwordGearComponent);
});

const RedIronPikeGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("red") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("speartype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomeiron")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_iron");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a red spearman`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:red_iron_pike_gear", RedIronPikeGearComponent);
});

const RedIronRangedGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("red") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("bowtype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomeiron")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_iron");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a red bowman`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:red_iron_ranged_gear", RedIronRangedGearComponent);
});

const RedDiamondSwordGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("red") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("swordtype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomediamond")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_diamond");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a red swordman`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:red_diamond_sword_gear", RedDiamondSwordGearComponent);
});

const RedDiamondPikeGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("red") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("speartype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomediamond")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_diamond");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a red speardman`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:red_diamond_pike_gear", RedDiamondPikeGearComponent);
});

const RedDiamondCrossbowGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("red") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("crossbowtype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomediamond")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_diamond");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a red crossbow soldier`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:red_diamond_crossbow_gear", RedDiamondCrossbowGearComponent);
});

const RedDiamondArcusBowGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("red") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("bowtype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomediamond")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_diamond");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a red bowman`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:red_diamond_arcus_bow_gear", RedDiamondArcusBowGearComponent);
});

const SteedSaddledComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomecavalry")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_cavalry' cho thực thể
            try {
                targetEntity.triggerEvent("become_cavalry");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a soldier can be cavalry`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:steed_saddled", SteedSaddledComponent);
});

const CamelWarSaddledComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomecamelwar")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_cavalry' cho thực thể
            try {
                targetEntity.triggerEvent("become_camel");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a soldier can be camel war soldier`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:camel_war_saddled", CamelWarSaddledComponent);
});

//GREY

// Định nghĩa custom component cho thanh kiếm đặc biệt
const GreyChampionGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("grey") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("battleaxetype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomechampion") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("steellv")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_berserker' cho thực thể
            try {
                targetEntity.triggerEvent("become_berserker");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a grey battle axe soldier level max`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:grey_champion_gear", GreyChampionGearComponent);
});

const GreyIronBattleAxeGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("grey") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("battleaxetype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomeiron")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_iron");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a grey battle axe soldier`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:grey_iron_battleaxe_gear", GreyIronBattleAxeGearComponent);
});

const GreyIronBowGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("grey") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("bowtype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomeiron")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_iron");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a grey bow soldier`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:grey_iron_bow_gear", GreyIronBowGearComponent);
});

const GreyIronHammerGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("grey") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("hammertype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomeiron")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_iron");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a grey hammer soldier`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:grey_iron_hammer_gear", GreyIronHammerGearComponent);
});

const GreyIronHeavyAxeGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("grey") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("axetype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomeiron")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_iron");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a grey axe soldier`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:grey_iron_heavyaxe_gear", GreyIronHeavyAxeGearComponent);
});

const GreyIronLongAxeGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("grey") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("longaxetype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomeiron")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_iron");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a grey long axe soldier`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:grey_iron_long_axe_gear", GreyIronLongAxeGearComponent);
});

const GreySteelBattleAxeGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("grey") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("battleaxetype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomesteel")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_steel");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a grey battle axe soldier`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:grey_steel_battleaxe_gear", GreySteelBattleAxeGearComponent);
});

const GreySteelBowGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("grey") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("bowtype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomesteel")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_steel");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a grey bow soldier`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:grey_steel_bow_gear", GreySteelBowGearComponent);
});

const GreySteelHammerGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("grey") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("hammertype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomesteel")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_steel");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a grey hammer soldier`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:grey_steel_hammer_gear", GreySteelHammerGearComponent);
});

const GreySteelHeavyAxeGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("grey") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("axetype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomesteel")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_steel");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a grey axe soldier`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:grey_steel_heavy_axe_gear", GreySteelHeavyAxeGearComponent);
});

const GreySteelLongAxeGearComponent = {
    onUse(event) {
        const player = event.source;
        const item = event.itemStack;

        // Lấy danh sách thực thể trong khoảng cách 4 blocks
        const entities = player.dimension.getEntities({
            location: player.location,
            maxDistance: 4
        });

        // Lọc thực thể thuộc type family 'becomespecial' và 'swordman'
        const targetEntity = entities.find(entity =>
            entity.hasComponent("minecraft:type_family") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("grey") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("longaxetype") &&
            entity.getComponent("minecraft:type_family").hasTypeFamily("becomesteel")
        );

        if (targetEntity) {
            // Thực hiện sự kiện 'become_diamond' cho thực thể
            try {
                targetEntity.triggerEvent("become_steel");
            } catch (error) {
                player.runCommandAsync("say Event không kích hoạt được.");
            }

            // Phát âm thanh beacon
            player.runCommandAsync("playsound beacon.activate @a ~ ~ ~ 2");
        } else {
            // Hiển thị thông báo khi không có thực thể thích hợp ở gần
            player.runCommandAsync(`title @s actionbar You need to stay near a grey long axe soldier`);
        }
    }
};

// Đăng ký custom component 'fv:special_sword_gear'
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:grey_steel_long_axe_gear", GreySteelLongAxeGearComponent);
});