import { world, Entity } from '@minecraft/server';

const GunChargedSoundComponent = {
    onCompleteUse(event) {
        const player = event.source; // Lấy người chơi (source entity)
        const itemStack = event.itemStack; // Lấy item stack hoàn thành việc sử dụng

        if (player instanceof Entity && itemStack) {
            // Lấy vị trí của người chơi
            const position = player.location;

            // Phát âm thanh totem tại vị trí người chơi
            const dimension = player.dimension;
            dimension.runCommandAsync(`playsound musket.charged @a ${position.x} ${position.y} ${position.z} 2`).then(() => {
                console.log("Played totem sound at player's position.");
            }).catch(error => {
                console.error("Failed to play totem sound:", error);
            });
        } else {
            console.warn("Source is not a valid player or itemStack is missing.");
        }
    }
};

// Đăng ký custom component fv:totem_sound_use
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:gun_charged_sound", GunChargedSoundComponent);
});

const GunChargingSoundComponent = {
    onUse(event) {
        const player = event.source; // Lấy người chơi (source entity)
        const itemStack = event.itemStack; // Lấy item stack hoàn thành việc sử dụng

        if (player instanceof Entity && itemStack) {
            // Lấy vị trí của người chơi
            const position = player.location;

            // Phát âm thanh totem tại vị trí người chơi
            const dimension = player.dimension;
            dimension.runCommandAsync(`playsound musket.locked @a ${position.x} ${position.y} ${position.z} 2`).then(() => {
                console.log("Played totem sound at player's position.");
            }).catch(error => {
                console.error("Failed to play totem sound:", error);
            });
        } else {
            console.warn("Source is not a valid player or itemStack is missing.");
        }
    }
};

// Đăng ký custom component fv:totem_sound_use
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:gun_charging_sound", GunChargingSoundComponent);
});

const RifleChargedSoundComponent = {
    onCompleteUse(event) {
        const player = event.source; // Lấy người chơi (source entity)
        const itemStack = event.itemStack; // Lấy item stack hoàn thành việc sử dụng

        if (player instanceof Entity && itemStack) {
            // Lấy vị trí của người chơi
            const position = player.location;

            // Phát âm thanh totem tại vị trí người chơi
            const dimension = player.dimension;
            dimension.runCommandAsync(`playsound rifle.load @a ${position.x} ${position.y} ${position.z} 2`).then(() => {
                console.log("Played totem sound at player's position.");
            }).catch(error => {
                console.error("Failed to play totem sound:", error);
            });
        } else {
            console.warn("Source is not a valid player or itemStack is missing.");
        }
    }
};

// Đăng ký custom component fv:totem_sound_use
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:rifle_charged_sound", RifleChargedSoundComponent);
});

const FlintlockChargedSoundComponent = {
    onCompleteUse(event) {
        const player = event.source; // Lấy người chơi (source entity)
        const itemStack = event.itemStack; // Lấy item stack hoàn thành việc sử dụng

        if (player instanceof Entity && itemStack) {
            // Lấy vị trí của người chơi
            const position = player.location;

            // Phát âm thanh totem tại vị trí người chơi
            const dimension = player.dimension;
            dimension.runCommandAsync(`playsound flintlock.charged @a ${position.x} ${position.y} ${position.z} 2`).then(() => {
                console.log("Played totem sound at player's position.");
            }).catch(error => {
                console.error("Failed to play totem sound:", error);
            });
        } else {
            console.warn("Source is not a valid player or itemStack is missing.");
        }
    }
};

// Đăng ký custom component fv:totem_sound_use
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:flintlock_charged_sound", FlintlockChargedSoundComponent);
});

const CrossbowChargedSoundComponent = {
    onCompleteUse(event) {
        const player = event.source; // Lấy người chơi (source entity)
        const itemStack = event.itemStack; // Lấy item stack hoàn thành việc sử dụng

        if (player instanceof Entity && itemStack) {
            // Lấy vị trí của người chơi
            const position = player.location;

            // Phát âm thanh totem tại vị trí người chơi
            const dimension = player.dimension;
            dimension.runCommandAsync(`playsound crossbow.loading.end @a ${position.x} ${position.y} ${position.z} 2`).then(() => {
                console.log("Played totem sound at player's position.");
            }).catch(error => {
                console.error("Failed to play totem sound:", error);
            });
        } else {
            console.warn("Source is not a valid player or itemStack is missing.");
        }
    }
};

// Đăng ký custom component fv:totem_sound_use
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:crossbow_charged_sound", CrossbowChargedSoundComponent);
});

const CrossbowChargingSoundComponent = {
    onUse(event) {
        const player = event.source; // Lấy người chơi (source entity)
        const itemStack = event.itemStack; // Lấy item stack hoàn thành việc sử dụng

        if (player instanceof Entity && itemStack) {
            // Lấy vị trí của người chơi
            const position = player.location;

            // Phát âm thanh totem tại vị trí người chơi
            const dimension = player.dimension;
            dimension.runCommandAsync(`playsound crossbow.loading.start @a ${position.x} ${position.y} ${position.z} 2`).then(() => {
                console.log("Played totem sound at player's position.");
            }).catch(error => {
                console.error("Failed to play totem sound:", error);
            });
        } else {
            console.warn("Source is not a valid player or itemStack is missing.");
        }
    }
};

// Đăng ký custom component fv:totem_sound_use
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:crossbow_charging_sound", CrossbowChargingSoundComponent);
});

const CrossbowQuickChargedSoundComponent = {
    onCompleteUse(event) {
        const player = event.source; // Lấy người chơi (source entity)
        const itemStack = event.itemStack; // Lấy item stack hoàn thành việc sử dụng

        if (player instanceof Entity && itemStack) {
            // Lấy vị trí của người chơi
            const position = player.location;

            // Phát âm thanh totem tại vị trí người chơi
            const dimension = player.dimension;
            dimension.runCommandAsync(`playsound crossbow.quick_charge.end @a ${position.x} ${position.y} ${position.z} 2`).then(() => {
                console.log("Played totem sound at player's position.");
            }).catch(error => {
                console.error("Failed to play totem sound:", error);
            });
        } else {
            console.warn("Source is not a valid player or itemStack is missing.");
        }
    }
};

// Đăng ký custom component fv:totem_sound_use
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:crossbow_quick_charged_sound", CrossbowQuickChargedSoundComponent);
});

const CrossbowQuickChargingSoundComponent = {
    onUse(event) {
        const player = event.source; // Lấy người chơi (source entity)
        const itemStack = event.itemStack; // Lấy item stack hoàn thành việc sử dụng

        if (player instanceof Entity && itemStack) {
            // Lấy vị trí của người chơi
            const position = player.location;

            // Phát âm thanh totem tại vị trí người chơi
            const dimension = player.dimension;
            dimension.runCommandAsync(`playsound crossbow.quick_charge.start @a ${position.x} ${position.y} ${position.z} 2`).then(() => {
                console.log("Played totem sound at player's position.");
            }).catch(error => {
                console.error("Failed to play totem sound:", error);
            });
        } else {
            console.warn("Source is not a valid player or itemStack is missing.");
        }
    }
};

// Đăng ký custom component fv:totem_sound_use
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:crossbow_quick_charging_sound", CrossbowQuickChargingSoundComponent);
});

const AncientTomeComponent = {
    onUse(event) {
        const player = event.source; // Lấy người chơi (source entity)
        const itemStack = event.itemStack; // Lấy item stack hoàn thành việc sử dụng

        if (player instanceof Entity && itemStack) {
            // Lấy vị trí của người chơi
            const position = player.location;

            // Phát âm thanh totem tại vị trí người chơi
            const dimension = player.dimension;
            dimension.runCommandAsync(`playsound beacon.activate @a ${position.x} ${position.y} ${position.z} 2`).then(() => {
                console.log("Played totem sound at player's position.");
            }).catch(error => {
                console.error("Failed to play totem sound:", error);
            });

            // Chạy lệnh xp 100 @s
            player.runCommandAsync(`xp 100 @s`).then(() => {
                console.log("Granted 100 XP to player.");
            }).catch(error => {
                console.error("Failed to grant XP:", error);
            });

            // Phát hiệu ứng particle totem tại vị trí người chơi
            player.runCommandAsync(`particle minecraft:totem_particle ${position.x} ${position.y} ${position.z}`).then(() => {
                console.log("Played totem particle effect at player's position.");
            }).catch(error => {
                console.error("Failed to play particle effect:", error);
            });
        } else {
            console.warn("Source is not a valid player or itemStack is missing.");
        }
    }
};

// Đăng ký custom component fv:ancient_tome_of_wisdom
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:ancient_tome_of_wisdom", AncientTomeComponent);
});

const CommanderTotemSoundComponent = {
    onUse(event) {
        const player = event.source; // Lấy người chơi (source entity)
        const itemStack = event.itemStack; // Lấy item stack hoàn thành việc sử dụng

        if (player instanceof Entity && itemStack) {
            // Lấy vị trí của người chơi
            const position = player.location;

            // Phát âm thanh totem tại vị trí người chơi
            const dimension = player.dimension;
            dimension.runCommandAsync(`playsound random.totem @a ${position.x} ${position.y} ${position.z} 2`).then(() => {
                console.log("Played totem sound at player's position.");
            }).catch(error => {
                console.error("Failed to play totem sound:", error);
            });

            // Phát hiệu ứng particle totem tại vị trí người chơi
            player.runCommandAsync(`particle minecraft:totem_particle ${position.x} ${position.y} ${position.z}`).then(() => {
                console.log("Played totem particle effect at player's position.");
            }).catch(error => {
                console.error("Failed to play particle effect:", error);
            });
        } else {
            console.warn("Source is not a valid player or itemStack is missing.");
        }
    }
};

// Đăng ký custom component fv:totem_sound_use
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:commander_totem_sound", CommanderTotemSoundComponent);
});
