import { world, Entity } from '@minecraft/server';

const LegonSwordUseComponent = {
    onCompleteUse(event) {
        const player = event.source; // Lấy người chơi (source entity)
        const itemStack = event.itemStack; // Lấy item stack hoàn thành việc sử dụng

        if (player instanceof Entity && itemStack) {
            // Áp dụng hiệu ứng strength cấp 0 trong 30 giây
            player.addEffect("resistance", 20 * 20, {
                amplifier: 1,  // Cấp độ 0
                showParticles: true
            });

            console.log("Applied speed to player.");
        } else {
            console.warn("Source is not a valid player or itemStack is missing.");
        }
    }
};

// Đăng ký custom component fv:spear_use_lv2
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:legon_sword_use", LegonSwordUseComponent);
});




const LegonSwordUseComponentMax = {
    onCompleteUse(event) {
        const player = event.source; // Lấy người chơi (source entity)
        const itemStack = event.itemStack; // Lấy item stack hoàn thành việc sử dụng

        if (player instanceof Entity && itemStack) {
            // Áp dụng hiệu ứng strength cấp 0 trong 30 giây
            player.addEffect("absorption", 20 * 20, {
                amplifier: 0,  // Cấp độ 0
                showParticles: true
            });

            console.log("Applied absorption to player.");
        } else {
            console.warn("Source is not a valid player or itemStack is missing.");
        }
    }
};

// Đăng ký custom component fv:spear_use_lv2
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:legon_sword_use_max", LegonSwordUseComponentMax);
});
