import { world, Entity } from '@minecraft/server';

const ScrimitaEffectPoisonComponent = {
    onHitEntity({ hitEntity }) {
        let chance = 0.95;  // Mặc định là 10% cơ hội
        let effectDuration = 7;  // Mặc định là 5 giây
        let effectAmplifier = 0;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("poison", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:scrimita_effect_poison", ScrimitaEffectPoisonComponent);
});

const ScrimitaEffectFatalPoisonComponent = {
    onHitEntity({ hitEntity }) {
        let chance = 0.05;  // Mặc định là 10% cơ hội
        let effectDuration = 5;  // Mặc định là 5 giây
        let effectAmplifier = 1;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("fatal_poison", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:scrimita_effect_fatal_poison", ScrimitaEffectFatalPoisonComponent);
});

const ScrimitaEffectPoisonMaxComponent = {
    onHitEntity({ hitEntity }) {
        let chance = 0.80;  // Mặc định là 10% cơ hội
        let effectDuration = 10;  // Mặc định là 5 giây
        let effectAmplifier = 1;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("poison", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:scrimita_effect_poison_max", ScrimitaEffectPoisonMaxComponent);
});

const ScrimitaEffectFatalPoisonMaxComponent = {
    onHitEntity({ hitEntity }) {
        let chance = 0.20;  // Mặc định là 10% cơ hội
        let effectDuration = 8;  // Mặc định là 5 giây
        let effectAmplifier = 1;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("fatal_poison", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:scrimita_effect_fatal_poison_max", ScrimitaEffectFatalPoisonMaxComponent);
});