import { world, Entity } from '@minecraft/server';

const VelocithiefBladePoisonComponent = {
    onHitEntity({ hitEntity }) {
        let chance = 0.20;  // Mặc định là 10% cơ hội
        let effectDuration = 5;  // Mặc định là 5 giây
        let effectAmplifier = 1;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("poison", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:velocithief_blade_poison", VelocithiefBladePoisonComponent);
});

const VelocithiefBladeSlownessComponent = {
    onHitEntity({ hitEntity }) {
        let chance = 0.80;  // Mặc định là 10% cơ hội
        let effectDuration = 10;  // Mặc định là 5 giây
        let effectAmplifier = 1;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("slowness", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:velocithief_blade_slowness", VelocithiefBladeSlownessComponent);
});

const VelocithiefBladePoisonV2Component = {
    onHitEntity({ hitEntity }) {
        let chance = 0.20;  // Mặc định là 10% cơ hội
        let effectDuration = 10;  // Mặc định là 5 giây
        let effectAmplifier = 1;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("poison", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:velocithief_blade_poison_v2", VelocithiefBladePoisonV2Component);
});

const VelocithiefBladePoisonV3Component = {
    onHitEntity({ hitEntity }) {
        let chance = 0.20;  // Mặc định là 10% cơ hội
        let effectDuration = 10;  // Mặc định là 5 giây
        let effectAmplifier = 1;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("fatal_poison", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:velocithief_blade_poison_v3", VelocithiefBladePoisonV3Component);
});

// Định nghĩa component fv:vampiric_health
const VelocithiefSpeedComponent = {
    onHitEntity({ hitEntity }) {
        // Xác suất 20% kích hoạt hiệu ứng
        if (Math.random() < 0.3) {
            // Lấy vị trí của thực thể bị đánh trúng
            const position = hitEntity.location;
            const dimension = hitEntity.dimension;

            // Áp dụng hiệu ứng regeneration cho người chơi cầm vũ khí
            dimension.runCommandAsync(`effect @p[c=1,hasitem={item=fv:velocithief_blade,location=slot.weapon.mainhand}] speed 10 0`).then(() => {
                console.log(`Applied regeneration effect to the player with steelblood vampiric cleaver at position ${position.x}, ${position.y}, ${position.z}`);
            }).catch(error => {
                console.error(`Failed to apply regeneration effect at position ${position.x}, ${position.y}, ${position.z}:`, error);
            });
        }
    }
};

// Đăng ký component fv:vampiric_health trong hệ thống
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:velocithief_speed", VelocithiefSpeedComponent);
});

const VelocithiefSpeedV2Component = {
    onHitEntity({ hitEntity }) {
        // Xác suất 20% kích hoạt hiệu ứng
        if (Math.random() < 0.4) {
            // Lấy vị trí của thực thể bị đánh trúng
            const position = hitEntity.location;
            const dimension = hitEntity.dimension;

            // Áp dụng hiệu ứng regeneration cho người chơi cầm vũ khí
            dimension.runCommandAsync(`effect @p[c=1,hasitem={item=fv:velocithief_blade_v2,location=slot.weapon.mainhand}] speed 10 1`).then(() => {
                console.log(`Applied regeneration effect to the player with steelblood vampiric cleaver at position ${position.x}, ${position.y}, ${position.z}`);
            }).catch(error => {
                console.error(`Failed to apply regeneration effect at position ${position.x}, ${position.y}, ${position.z}:`, error);
            });
        }
    }
};

// Đăng ký component fv:vampiric_health trong hệ thống
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:velocithief_speed_v2", VelocithiefSpeedV2Component);
});

const VelocithiefSpeedV3Component = {
    onHitEntity({ hitEntity }) {
        // Xác suất 20% kích hoạt hiệu ứng
        if (Math.random() < 0.5) {
            // Lấy vị trí của thực thể bị đánh trúng
            const position = hitEntity.location;
            const dimension = hitEntity.dimension;

            // Áp dụng hiệu ứng regeneration cho người chơi cầm vũ khí
            dimension.runCommandAsync(`effect @p[c=1,hasitem={item=fv:velocithief_blade_v3,location=slot.weapon.mainhand}] speed 10 2`).then(() => {
                console.log(`Applied regeneration effect to the player with steelblood vampiric cleaver at position ${position.x}, ${position.y}, ${position.z}`);
            }).catch(error => {
                console.error(`Failed to apply regeneration effect at position ${position.x}, ${position.y}, ${position.z}:`, error);
            });
        }
    }
};

// Đăng ký component fv:vampiric_health trong hệ thống
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:velocithief_speed_v3", VelocithiefSpeedV3Component);
});