import { world, Entity } from '@minecraft/server';

const WitheringSpearEffectComponent = {
    onHitEntity({ hitEntity }) {
        let chance = 1;  // Mặc định là 10% cơ hội
        let effectDuration = 5;  // Mặc định là 5 giây
        let effectAmplifier = 0;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("wither", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:withering_spear", WitheringSpearEffectComponent);
});

const WitheringSpearEffectLv2Component = {
    onHitEntity({ hitEntity }) {
        let chance = 1;  // Mặc định là 10% cơ hội
        let effectDuration = 10;  // Mặc định là 5 giây
        let effectAmplifier = 0;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("wither", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:withering_spear_lv2", WitheringSpearEffectLv2Component);
});

const WitheringSpearEffectLv3Component = {
    onHitEntity({ hitEntity }) {
        let chance = 1;  // Mặc định là 10% cơ hội
        let effectDuration = 10;  // Mặc định là 5 giây
        let effectAmplifier = 1;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("wither", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:withering_spear_lv3", WitheringSpearEffectLv3Component);
});

const WitheringStrenghComponent = {
    onHitEntity({ hitEntity }) {
        // Xác suất 20% kích hoạt hiệu ứng
        if (Math.random() < 0.2) {
            // Lấy vị trí của thực thể bị đánh trúng
            const position = hitEntity.location;
            const dimension = hitEntity.dimension;

            // Áp dụng hiệu ứng regeneration cho người chơi cầm vũ khí
            dimension.runCommandAsync(`effect @p[c=1,hasitem={item=fv:withering_spear_lv1,location=slot.weapon.mainhand}] strength 10 0`).then(() => {
                console.log(`Applied regeneration effect to the player with steelblood vampiric cleaver at position ${position.x}, ${position.y}, ${position.z}`);
            }).catch(error => {
                console.error(`Failed to apply regeneration effect at position ${position.x}, ${position.y}, ${position.z}:`, error);
            });
        }
    }
};

// Đăng ký component fv:vampiric_health trong hệ thống
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:withering_strengh", WitheringStrenghComponent);
});

const WitheringStrenghV2Component = {
    onHitEntity({ hitEntity }) {
        // Xác suất 20% kích hoạt hiệu ứng
        if (Math.random() < 0.5) {
            // Lấy vị trí của thực thể bị đánh trúng
            const position = hitEntity.location;
            const dimension = hitEntity.dimension;

            // Áp dụng hiệu ứng regeneration cho người chơi cầm vũ khí
            dimension.runCommandAsync(`effect @p[c=1,hasitem={item=fv:withering_spear_lv2,location=slot.weapon.mainhand}] strength 10 0`).then(() => {
                console.log(`Applied regeneration effect to the player with steelblood vampiric cleaver at position ${position.x}, ${position.y}, ${position.z}`);
            }).catch(error => {
                console.error(`Failed to apply regeneration effect at position ${position.x}, ${position.y}, ${position.z}:`, error);
            });
        }
    }
};

// Đăng ký component fv:vampiric_health trong hệ thống
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:withering_strengh_v2", WitheringStrenghV2Component);
});

const WitheringStrenghV3Component = {
    onHitEntity({ hitEntity }) {
        // Xác suất 20% kích hoạt hiệu ứng
        if (Math.random() < 0.5) {
            // Lấy vị trí của thực thể bị đánh trúng
            const position = hitEntity.location;
            const dimension = hitEntity.dimension;

            // Áp dụng hiệu ứng regeneration cho người chơi cầm vũ khí
            dimension.runCommandAsync(`effect @p[c=1,hasitem={item=fv:withering_spear_lv3,location=slot.weapon.mainhand}] strength 10 1`).then(() => {
                console.log(`Applied regeneration effect to the player with steelblood vampiric cleaver at position ${position.x}, ${position.y}, ${position.z}`);
            }).catch(error => {
                console.error(`Failed to apply regeneration effect at position ${position.x}, ${position.y}, ${position.z}:`, error);
            });
        }
    }
};

// Đăng ký component fv:vampiric_health trong hệ thống
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:withering_strengh_v3", WitheringStrenghV3Component);
});