import { world, Entity } from '@minecraft/server';

const DesertSwordEffectComponent = {
    onHitEntity({ hitEntity }) {
        let chance = 0.15;  // Mặc định là 10% cơ hội
        let effectDuration = 3;  // Mặc định là 5 giây
        let effectAmplifier = 0;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("poison", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:desert_sword_effect", DesertSwordEffectComponent);
});

const DesertSwordEffectComponentLv2 = {
    onHitEntity({ hitEntity }) {
        let chance = 0.20;  // Mặc định là 10% cơ hội
        let effectDuration = 5;  // Mặc định là 5 giây
        let effectAmplifier = 0;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("poison", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:desert_sword_effect_lv2", DesertSwordEffectComponentLv2);
});

const DesertSwordEffectComponentLv3 = {
    onHitEntity({ hitEntity }) {
        let chance = 0.25;  // Mặc định là 10% cơ hội
        let effectDuration = 8;  // Mặc định là 5 giây
        let effectAmplifier = 1;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("poison", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:desert_sword_effect_lv3", DesertSwordEffectComponentLv3);
});