import { world } from '@minecraft/server';

const HammerEffectComponent = {
    onHitEntity({ hitEntity }) {
        let chance = 0.10;  // Mặc định là 10% cơ hội
        let effectDuration = 2;  // Mặc định là 5 giây
        let effectAmplifier = 10;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("slowness", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });

            // Lấy vị trí của thực thể bị đánh trúng
            const position = hitEntity.location;
            const dimension = hitEntity.dimension;

            // Phát âm thanh tại vị trí của thực thể bị đánh trúng
            dimension.runCommandAsync(`playsound weapon.bonk @a ${position.x} ${position.y} ${position.z} 4`).then(() => {
                console.log(`Executed hammer_sound at position ${position.x}, ${position.y}, ${position.z}`);
            }).catch(error => {
                console.error(`Failed to execute playsound at position ${position.x}, ${position.y}, ${position.z}:`, error);
            });
        }
    }
};

// Đăng ký custom component fv:hammer_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:hammer_effect", HammerEffectComponent);
});

const HammerEffectComponentLv2 = {
    onHitEntity({ hitEntity }) {
        let chance = 0.15;  // Mặc định là 10% cơ hội
        let effectDuration = 4;  // Mặc định là 5 giây
        let effectAmplifier = 10;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("slowness", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });

            // Lấy vị trí của thực thể bị đánh trúng
            const position = hitEntity.location;
            const dimension = hitEntity.dimension;

            // Phát âm thanh tại vị trí của thực thể bị đánh trúng
            dimension.runCommandAsync(`playsound weapon.bonk @a ${position.x} ${position.y} ${position.z} 4`).then(() => {
                console.log(`Executed hammer_sound at position ${position.x}, ${position.y}, ${position.z}`);
            }).catch(error => {
                console.error(`Failed to execute playsound at position ${position.x}, ${position.y}, ${position.z}:`, error);
            });
        }
    }
};

// Đăng ký custom component fv:hammer_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:hammer_effect_lv2", HammerEffectComponentLv2);
});

const HammerEffectComponentLv3 = {
    onHitEntity({ hitEntity }) {
        let chance = 0.2;  // Mặc định là 10% cơ hội
        let effectDuration = 6;  // Mặc định là 5 giây
        let effectAmplifier = 10;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("slowness", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });

            // Lấy vị trí của thực thể bị đánh trúng
            const position = hitEntity.location;
            const dimension = hitEntity.dimension;

            // Phát âm thanh tại vị trí của thực thể bị đánh trúng
            dimension.runCommandAsync(`playsound weapon.bonk @a ${position.x} ${position.y} ${position.z} 4`).then(() => {
                console.log(`Executed hammer_sound at position ${position.x}, ${position.y}, ${position.z}`);
            }).catch(error => {
                console.error(`Failed to execute playsound at position ${position.x}, ${position.y}, ${position.z}:`, error);
            });
        }
    }
};

// Đăng ký custom component fv:hammer_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:hammer_effect_lv3", HammerEffectComponentLv3);
});