import './redfaction';
import './bluefaction';
import './greyfaction';
import './leaguefaction';
import './hammer.js';
import './spear_effect.js';
import './Item_Use/spear_use.js';
import './pike_effect.js';
import './Item_Use/pike_use.js';
import './desert_sword_effect.js';
import './BigSwordApplyDamage.js';
import './BattleAxe.js';
import './HeavyAxe.js';
import './SaberEffect.js';
import './ScrimitaEffect.js';
import './Item_Use/ScrimitaUse.js';
import './LegonSwordEffect.js';
import './Item_Use/LegonSwordUse.js';
import './AxeOfBerserker.js';
import './Item_Use/AxeOfBerserkerUse.js';
import './GiantGemHeartBoardSword.js';
import './Item_Use/GiantGemHeartBoardSwordUse.js';
import './SteelBloodVampiricCleaver.js';
import './VelocithiefBlade.js';
import './WitheringSpearEffect.js';
import './DefenderWeapon.js';
import './Item_Use/DefenderWeapon.js';
import './Item_Use/FunctionUse.js';
import './Item_Use/CallHorn.js';
import './Item_Use/Gears.js';
import './Item_Use/Gun.js';
import { world, system, DisplaySlotId } from "@minecraft/server";

// Hàm khởi tạo và hiển thị scoreboard cho Biome Boss Kills
function setupMainBossKills(player) {
    const objtest = world.scoreboard.getObjective("MainBossKills");
    if (!objtest) {
        // Khởi tạo objective nếu chưa tồn tại
        system.run(() => {
            world.scoreboard.addObjective("MainBossKills", "Main Boss Kills");
            const d = world.scoreboard.getObjective("MainBossKills");
            if (player) {
                d.addScore(player, 0); // Khởi tạo điểm cho người chơi
            }
        });
    }

    // Hiển thị Biome Boss Kills dưới tên người chơi (belowname)
    world.scoreboard.setObjectiveAtDisplaySlot(DisplaySlotId.BelowName, {
        objective: world.scoreboard.getObjective("MainBossKills"),
    });

    player.sendMessage("Scoreboard Main Boss Kills đã được cập nhật.");
}

// Hàm cập nhật scoreboard cho người chơi chưa có tag "joined"
function updateScoreboardForNewPlayers() {
    const players = world.getPlayers(); // Lấy danh sách người chơi hiện tại

    players.forEach(player => {
        // Kiểm tra nếu người chơi không có tag "joined"
        if (!player.hasTag("joined")) {

            // Khởi tạo và hiển thị scoreboard cho Main Boss Kills và Biome Boss Kills
            setupMainBossKills(player);

            // Thêm tag "joined" cho người chơi sau khi setup xong scoreboard
            player.addTag("joined");

            // Gửi thông báo chào mừng
            player.sendMessage("Chào mừng " + player.name + "! Scoreboard đã được cập nhật.");
        }
    });
}

// Chạy kiểm tra người chơi mới để cập nhật scoreboard
system.runInterval(() => {
    updateScoreboardForNewPlayers(); // Cập nhật chỉ cho người chơi chưa có tag "joined"
}, 20); // Thực thi mỗi 1 giây



//Player Name

// Hàm lấy màu sắc và tag dựa trên faction của người chơi
function getFactionNameTag(player) {
    if (player.hasTag('red')) {
        return '§c[Red] ' + player.name;  // Màu đỏ cho phe Red
    } else if (player.hasTag('grey')) {
        return '§7[Grey] ' + player.name;  // Màu xám cho phe Grey
    } else if (player.hasTag('blue')) {
        return '§9[Blue] ' + player.name;  // Màu xanh biển cho phe Blue
    } else if (player.hasTag('league')) {
        return '§b[League] ' + player.name;  // Màu xanh da trời cho phe League
    }
    return '§f' + player.name;  // Màu trắng mặc định nếu không thuộc faction nào
}

// Cập nhật nameTag của tất cả người chơi liên tục theo tag của họ
system.runInterval(() => {
    for (const player of world.getPlayers()) {
        // Cập nhật nameTag của người chơi dựa trên faction (tag) của họ
        player.nameTag = getFactionNameTag(player);
    }
}, 20);  // Cập nhật mỗi 20 ticks (khoảng 1 giây)
