import { world, system } from "@minecraft/server";

// Hàm kiểm tra nếu item có tag "minecraft:netherite_tier"
function isNetheriteItem(entity) {
    const item = entity.getComponent("minecraft:item");

    if (item && item.itemStack.hasTag("minecraft:netherite_tier")) {
        return true;
    }
    return false;
}

// Hàm kiểm tra và bảo vệ item netherite khỏi cháy trong lava
function protectNetheriteItems() {
    const entities = world.getEntities(); // Lấy tất cả thực thể trong thế giới

    entities.forEach(entity => {
        if (entity.typeId === "minecraft:item") {
            // Kiểm tra nếu item có tag "minecraft:netherite_tier" và đang ở trong lava hoặc lửa
            if (isNetheriteItem(entity) && (entity.isInLava || entity.isOnFire)) {
                // Dập tắt lửa và ngăn cháy
                entity.extinguish(); // Dập tắt lửa
            }
        }
    });
}

// Chạy kiểm tra định kỳ để bảo vệ các item netherite
system.runInterval(() => {
    protectNetheriteItems(); // Bảo vệ item netherite khỏi cháy
}, 20); // Kiểm tra mỗi giây
