import { world, Entity } from '@minecraft/server';

const PikeEffectComponent = {
    onHitEntity({ hitEntity }) {
        let chance = 0.15;  // Mặc định là 10% cơ hội
        let effectDuration = 5;  // Mặc định là 5 giây
        let effectAmplifier = 1;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("slowness", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:pike_effect", PikeEffectComponent);
});

const PikeEffectComponentLv2 = {
    onHitEntity({ hitEntity }) {
        let chance = 0.20;  // Mặc định là 10% cơ hội
        let effectDuration = 10;  // Mặc định là 5 giây
        let effectAmplifier = 1;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("slowness", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:pike_effect_lv2", PikeEffectComponentLv2);
});

const PikeEffectComponentLv3 = {
    onHitEntity({ hitEntity }) {
        let chance = 0.25;  // Mặc định là 10% cơ hội
        let effectDuration = 15;  // Mặc định là 5 giây
        let effectAmplifier = 2;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("slowness", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:pike_effect_lv3", PikeEffectComponentLv3);
});