import { world, system, Player, ItemStack, Entity, Dimension } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";

function main(player) {
    // Check if the player already has the 'red' tag
    if (player.hasTag('red')) {
        player.sendMessage('You are already a member of the red faction.');
        return;
    }

    if (player.hasTag('blue')) {
        player.sendMessage('You are already a member of the blue faction.');
        return;
    }

    if (player.hasTag('grey')) {
        player.sendMessage('You are already a member of the grey faction.');
        return;
    }

    if (player.hasTag('league')) {
        player.sendMessage('You are already a member of the league faction.');
        return;
    }

    const form = new ActionFormData();
    form.title('Red Faction');
    form.body('Do you want to join the red faction?');
    form.button('Yes, I want to.');
    form.button('No, Next time.');

    form.show(player).then(response => {
        if (response.selection === 0) {
            system.run(() => {
                player.addTag('red');
                player.sendMessage('Welcome to the red faction!');
            });
        } else {
            player.sendMessage('Maybe next time!');
        }
    });
}
// Event listener for item use
world.beforeEvents.itemUse.subscribe(eventData => {
    const player = eventData.source;
    const item = eventData.itemStack;

    // Check if the item used is a compass
    if (item.typeId === 'fv:red_faction_book') {
        system.run(() => main(player));
    }
});