import { world, Entity } from '@minecraft/server';

const SpearEffectComponent = {
    onHitEntity({ hitEntity }) {
        let chance = 0.20;  // Mặc định là 10% cơ hội
        let effectDuration = 10;  // Mặc định là 5 giây
        let effectAmplifier = 0;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("slowness", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:spear_effect", SpearEffectComponent);
});

const SpearEffectComponentLv2 = {
    onHitEntity({ hitEntity }) {
        let chance = 0.30;  // Mặc định là 10% cơ hội
        let effectDuration = 20;  // Mặc định là 5 giây
        let effectAmplifier = 0;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("slowness", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:spear_effect_lv2", SpearEffectComponentLv2);
});

const SpearEffectComponentLv3 = {
    onHitEntity({ hitEntity }) {
        let chance = 0.30;  // Mặc định là 10% cơ hội
        let effectDuration = 25;  // Mặc định là 5 giây
        let effectAmplifier = 1;  // Cấp độ của hiệu ứng luôn là 10

        // Áp dụng hiệu ứng nếu xác suất xảy ra
        if (Math.random() < chance) {
            hitEntity.addEffect("slowness", effectDuration * 20, {
                amplifier: effectAmplifier,
                showParticles: true
            });
        }
    }
};

// Đăng ký custom component fv:spear_effect
world.beforeEvents.worldInitialize.subscribe(({ itemComponentRegistry }) => {
    itemComponentRegistry.registerCustomComponent("fv:spear_effect_lv3", SpearEffectComponentLv3);
});